<?php

namespace Acms\Plugins\ShoppingCart\Entities;

use Acms\Plugins\ShoppingCart\Entities\Master\Status;

/**
 * 決済方法
 */
class Payment
{
    /**
     * ブロック名
     *
     * @var string
     */
    private $block;

    /**
     * ステータス
     *
     * @var string
     */
    private $status = Status::OPEN;

    /**
     * 決済方法名
     *
     * @var string
     */
    private $name;

    /**
     * 手数料
     *
     * @var int
     */
    private $commissionPaid = 0;

    /**
     * 利用条件による設定を行うか
     *
     * @var bool
     */
    private $isRuleEnabled = false;

    /**
     * 説明テキスト
     *
     * @var string
     */
    private $description = '';

    /**
     * メール用テキスト
     *
     * @var string
     */
    private $mailMessage = '';

    /**
     * 画像
     *
     * @var Media|null
     */
    private $Media;

    /**
     * 条件による決済手数料
     *
     * @var PaymentRule[]
     */
    private $PaymentRules = [];

    public function getBlock(): ?string
    {
        return $this->block;
    }

    public function setBlock(string $block): void
    {
        $this->block = $block;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }

    public function setStatus(string $status = Status::OPEN)
    {
        $this->status = $status;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name)
    {
        $this->name = $name;
    }

    public function getCommissionPaid(): int
    {
        return $this->commissionPaid;
    }

    public function setCommissionPaid(int $commissionPaid = 0): void
    {
        $this->commissionPaid = $commissionPaid;
    }

    public function getIsRuleEnabled(): bool
    {
        return $this->isRuleEnabled;
    }

    public function setIsRuleEnabled(bool $isRuleEnabled): void
    {
        $this->isRuleEnabled = $isRuleEnabled;
    }

    public function getDescription(): string
    {
        return $this->description;
    }

    public function setDescription(string $description = ''): void
    {
        $this->description = $description;
    }

    public function getMailMessage(): string
    {
        return $this->mailMessage;
    }

    public function setMailMessage(string $mailMessage = ''): void
    {
        $this->mailMessage = $mailMessage;
    }

    public function getMedia(): ?Media
    {
        return $this->Media;
    }

    public function setMedia(?Media $Media): void
    {
        $this->Media = $Media;
    }

    public function getPaymentRules(): ?array
    {
        return $this->PaymentRules;
    }

    public function setPaymentRules(array $PaymentRules = []): void
    {
        $this->PaymentRules = $PaymentRules;
    }
}
