<?php

namespace Acms\Plugins\ShoppingCart\Entities;

/**
 * 決済方法の利用条件
 */
class PaymentRule
{
    /**
     * 下限価格
     *
     * @var int
     */
    private $priceMin = 0;

    /**
     * 上限価格
     *
     * @var int|null
     */
    private $priceMax;

    /**
     * 手数料
     *
     * @var int
     */
    private $commission = 0;

    public function getPriceMin(): int
    {
        return $this->priceMin;
    }

    public function setPriceMin(int $priceMin = 0): void
    {
        $this->priceMin = $priceMin;
    }

    public function getPriceMax(): ?int
    {
        return $this->priceMax;
    }

    public function setPriceMax(?int $priceMax): void
    {
        $this->priceMax = $priceMax;
    }

    public function getCommission(): int
    {
        return $this->commission;
    }

    public function setCommission(int $commission = 0): void
    {
        $this->commission = $commission;
    }
}
