<?php

namespace Acms\Plugins\ShoppingCart\Entities;

use Acms\Plugins\ShoppingCart\Entities\Shipping;
use Acms\Plugins\ShoppingCart\Entities\Master\ShippingGroupCalcMethod;
use Acms\Plugins\ShoppingCart\Entities\Master\Status;

/**
 * 配送グループ
 */
class ShippingGroup
{
    /**
     * 配送グループID
     *
     * @var string
     */
    private $id;

    /**
     * ステータス
     *
     * @var string
     */
    private $status = Status::OPEN;

    /**
     * 配送グループ名
     *
     * @var string
     */
    private $name;

    /**
     * 全国一律の送料
     *
     * @var int
     */
    private $groupFee = 0;


    /**
     * 送料の計算方法
     *
     * @var string
     */
    private $calcMethod = ShippingGroupCalcMethod::ITEM;

    /**
     * 送料設定
     *
     * @var Shipping[]
     */
    private $Shippings = [];

    public function getId(): string
    {
        return $this->id;
    }

    public function setId(string $id): void
    {
        $this->id = $id;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }

    public function setStatus(string $status = Status::OPEN)
    {
        $this->status = $status;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(?string $name): void
    {
        $this->name = $name;
    }

    public function getGroupFee(): int
    {
        return $this->groupFee;
    }

    public function setGroupFee(int $groupFee = 0): void
    {
        $this->groupFee = $groupFee;
    }


    public function getCalcMethod(): string
    {
        return $this->calcMethod;
    }

    public function setCalcMethod(?string $calcMethod = ShippingGroupCalcMethod::ITEM): void
    {
        $this->calcMethod = $calcMethod;
    }

    public function getShippings(): array
    {
        return $this->Shippings;
    }

    public function setShippings(array $Shippings = []): void
    {
        $this->Shippings = $Shippings;
    }
}
