<?php

namespace Acms\Plugins\ShoppingCart\GET\Admin\ShippingGroup;

use Acms\Plugins\ShoppingCart\Entities\Shipping;
use Acms\Plugins\ShoppingCart\Entities\ShippingGroup as ShippingGroupEntity;
use Acms\Plugins\ShoppingCart\Repositories\ConfigRepository;
use Acms\Plugins\ShoppingCart\GET\ShoppingCart\Settings;
use ACMS_Corrector;
use Template;
use Config;

/**
 * 配送グループの設定を表示する
 *
 * ShoppingCart_Settingsモジュールでは管理画面から配送グループの設定を変更した場合、
 * 反映にリロードが必要になるため、専用で用意する
 */
class Index extends Settings
{
    public function get()
    {
        $Tpl = new Template($this->tpl, new ACMS_Corrector());

        // コンフィグを再ロード
        $Config = Config::loadDefaultField();
        $Config->overload(Config::loadBlogConfig(BID));

        $this->Config = new ConfigRepository($Config);

        return $Tpl->render([
            'shippingGroup' => $this->buildShippingGroup(),
        ]);
    }
}
