<?php

namespace Acms\Plugins\ShoppingCart\GET;

use ACMS_GET_Admin_User_Edit;

/**
 * 閲覧ページ上からユーザー情報を編集する（非推奨）
 */
class Mypage extends ACMS_GET_Admin_User_Edit
{
    public function auth()
    {
        if (!SUID) {
            return false;
        }
        return true;
    }

    public function edit(&$Tpl)
    {
        $User = loadUser(SUID);
        $User->delete('pass');
        $User_ = $this->Post->getChild('user');
        $User->overload($User_);

        if ($User->isNull()) {
            //---------
            // default
            $User->set('status', 'open');
            $User->set('auth', 'contributor');
            $User->set('indexing', 'on');
            $User->set('mail_magazine', 'on');
            $User->set('mail_mobile_magazine', 'on');
            $User->set('login_anywhere', 'off');
            $User->set('login_expire', '9999-12-31');
            $User->set('global_auth', 'on');
        } else {
            switch (getAuthConsideringRole(SUID)) {
                case 'subscriber':
                    $User->set('actually_auth', 'subscriber');
                    break;
                case 'contributor':
                    $User->set('actually_auth', 'contributor');
                    break;
                case 'editor':
                    $User->set('actually_auth', 'editor');
                    break;
                case 'administrator':
                    $User->set('actually_auth', 'administrator');
                    break;
            }
            if (isRoleAvailableUser(SUID)) {
                $User->set('role_management', 'yes');
            }
        }
        if (!!SUID) {
            $User->set('oldPass', $User->get('oldPass'));
        }
        if (GETTEXT_TYPE !== 'user') {
            $User->delete('locale');
        }
        if (!sessionWithAdministration()) {
            $User->delete('status');
            $User->delete('auth');
            $User->delete('indexing');
            $User->delete('login_anywhere');
            $User->delete('global_auth');
            $User->delete('login_expire');
            $User->delete('login_terminal_restriction');
            $User->delete('locale');
        }
        $this->Post->addChild('user', $User);

        $Field =& $this->Post->getChild('field');
        if ($Field->isNull() && !!SUID) {
            $Field->overload(loadUserField(SUID));
        }
        if ($message = config('password_validator_message')) {
            $Field->set('passwordPolicyMessage', $message);
        }

        return true;
    }
}
