<?php

namespace Acms\Plugins\ShoppingCart\GET\Square;

use App;
use ACMS_Corrector;
use ACMS_GET;
use Template;
use Acms\Plugins\ShoppingCart\Repositories\ConfigRepository;

class Script extends ACMS_GET
{
    /**
     * @var ConfigRepository
     */
    protected $Config;

    public function get()
    {
        $this->Config = App::make('shopping-cart.repository.config');

        $Tpl = new Template($this->tpl, new ACMS_Corrector());

        return $Tpl->render([
            'SquareApplicationID' => $this->getApplicationId(),
            'SquareLocationID' => $this->getLocationId(),
            'SquareEnvironment' => $this->isSandbox() ? 'sandbox' : 'production'
        ]);
    }

    protected function getApplicationId()
    {
        if ($this->isSandbox()) {
            return $this->Config->get('SandboxSquareApplicationID');
        }
        return $this->Config->get('SquareApplicationID');
    }

    protected function getLocationId()
    {
        if ($this->isSandbox()) {
            return $this->Config->get('SandboxSquareLocationID');
        }
        return $this->Config->get('SquareLocationID');
    }

    private function isSandbox()
    {
        return $this->Config->get('SquareSandbox') === 'on';
    }
}
