<?php

namespace Acms\Plugins\ShoppingCart\POST\Square;

use App;
use ACMS_POST;
use Session;
use Acms\Plugins\ShoppingCart\Plugins\Square\Services\OAuth\Contracts\AbstractSquareOAuthService;

/**
 * Square OAuthの認証処理を行う
 */
class Auth extends ACMS_POST
{
    /**
     * @var AbstractSquareOAuthService
     */
    protected $SquareOAuthService;

    /**
     * constructor
     */
    public function __construct()
    {
        $this->SquareOAuthService = App::make('square.service.oauth');
    }

    public function post()
    {
        $state = uniqueString();

        $session = Session::handle();
        $session->set('square_state', $state);
        $session->save();

        // Squareの認証画面にリダイレクトする
        redirect($this->SquareOAuthService->buildUrlGettingAuthorizationCode($state));
    }
}
