<?php

namespace Acms\Plugins\ShoppingCart\Plugins\Square\Services\OAuth;

use Acms\Contracts\Factory;
use App;
use Config;

class SquareOAuthFactory extends Factory
{
    /**
     * Factory
     *
     * @return mixed
     */
    public function createInstance()
    {
        if ($this->isSandbox(BID)) {
            return App::make('square.service.oauth.sandbox');
        }

        return App::make('square.service.oauth.production');
    }

    /**
     * Sandboxモードかどうか
     *
     * @param int $bid
     * @return bool
     */
    private function isSandbox($bid = BID)
    {
        // 管理画面でSandboxモードとProductionモードの切り替えをした時に、
        // モードの切替が反映されるようにするために毎回コンフィグをロードする。
        $Config = Config::loadBlogConfig($bid);
        return ($Config->get('SquareSandbox') === 'on');
    }
}
