<?php

namespace Acms\Plugins\ShoppingCart\Plugins\Square\Webhook;

use AcmsLogger;
use Common;
use Slim\Factory\AppFactory;

try {
    $app = AppFactory::create();

    if (is_string(DIR_OFFSET) && DIR_OFFSET !== '') {
        $app->setBasePath('/' . DIR_OFFSET);
    }
    $app->addBodyParsingMiddleware();
    $isDebugMode = function_exists('isDebugMode') ? isDebugMode() : !!DEBUG_MODE;
    $app->addErrorMiddleware($isDebugMode, false, false);

    $app->post('/bid/{bid}/webhook/shopping-cart/square/', Controller::class . ':handle');

    $app->run();
} catch (\Exception $e) {
    if (class_exists('AcmsLogger')) {
        AcmsLogger::error('【Shopping Cart plugin】SquareのWebhook機能で例外が発生しました。', Common::exceptionArray($e));
    } else {
        userErrorLog('ACMS Error: ShoppingCart Exception -> ' . $e->getMessage());
    }
} finally {
    die();
}
