import { creditCard } from './payment-method';

import { Payments } from '@square/web-payments-sdk-types';
import { AcmsSquarePayments } from './types';

// eslint-disable-next-line import/prefer-default-export
export const createPayments = ({ applicationId, locationId }: AcmsSquarePayments) => {
  if (!window.Square) {
    throw new Error('Square.js failed to load properly');
  }
  let payments: Payments;
  try {
    payments = window.Square.payments(applicationId, locationId);
  } catch (e) {
    console.error(e); // eslint-disable-line no-console
    return;
  }

  return {
    creditCard: creditCard(payments),
  };
};
