export const appendField = (name: string, value: string, context: Document | Element) => {
  let input = context.querySelector<HTMLInputElement>(`[name="${name}"]`);

  if (input === null) {
    input = document.createElement('input');
    input.type = 'hidden';
    input.name = name;
    context.appendChild(input);
  }

  input.value = value;

  if (context.querySelector<HTMLInputElement>(`[name="field[]"][value="${name}"]`) === null) {
    const field = document.createElement('input');
    field.type = 'hidden';
    field.name = 'field[]';
    field.value = name;
    context.appendChild(field);
  }
};

export const triggerEvent = (element: EventTarget, eventName: string, options: CustomEventInit = {}) => {
  element.dispatchEvent(new CustomEvent(eventName, options));
};
