<?php

namespace Acms\Plugins\ShoppingCart\Services\Payment\Methods;

use Acms\Plugins\ShoppingCart\Entities\Order;
use Acms\Plugins\ShoppingCart\Services\Payment\PaymentMethodInterface;
use Acms\Plugins\ShoppingCart\Services\Payment\PaymentResult;
use Field;

/**
 * 銀行振込, 代金引き換えなど, 主に現金を扱う支払い方法を扱うクラス.
 */
class Cash implements PaymentMethodInterface
{
    /**
     * 注文情報
     *
     * @var Order
     */
    private $Order;

    /**
     * Post
     *
     * @var Field
     */
    private $Post;

    /**
     * {@inheritdoc}
     */
    public function getCode(): string
    {
        return 'cash';
    }

    /**
     * {@inheritdoc}
     */
    public function verify(): PaymentResult
    {
        $PaymentResult = new PaymentResult();
        $PaymentResult->setSuccess(true);

        return $PaymentResult;
    }

    /**
     * {@inheritdoc}
     */
    public function checkout(): PaymentResult
    {
        $PaymentResult = new PaymentResult();
        $PaymentResult->setSuccess(true);

        return $PaymentResult;
    }

    /**
     * {@inheritdoc}
     */
    public function setOrder(Order $Order): PaymentMethodInterface
    {
        $this->Order = $Order;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function setPost(Field $Post): PaymentMethodInterface
    {
        $this->Post = $Post;

        return $this;
    }
}
