<?php

namespace Acms\Plugins\ShoppingCart\Services\Payment\Methods;

use Acms\Plugins\ShoppingCart\Entities\Order;
use Acms\Plugins\ShoppingCart\Services\Payment\PaymentMethodInterface;
use Acms\Plugins\ShoppingCart\Services\Payment\PaymentResult;
use Field;

/**
 * クレジットカード払いの基底クラス.
 *
 * クレジットカード決済を実装する場合は, このクラスを継承します.
 */
abstract class CreditCard implements PaymentMethodInterface
{
    /**
     * @var Order
     */
    protected $Order;

    /**
     * @var Field
     */
    protected $Post;

    /**
     * {@inheritdoc}
     */
    abstract public function verify(): PaymentResult;

    /**
     * {@inheritdoc}
     */
    abstract public function checkout(): PaymentResult;

    /**
     * {@inheritdoc}
     */
    public function setOrder(Order $Order): PaymentMethodInterface
    {
        $this->Order = $Order;

        return $this;
    }


    /**
     * {@inheritdoc}
     */
    public function setPost(Field $Post): PaymentMethodInterface
    {
        $this->Post = $Post;

        return $this;
    }
}
