<?php

namespace Acms\Plugins\ShoppingCart\Services\Payment\Methods;

use Acms\Services\Common\Factory;

class CreditCardFactory extends Factory
{
    /**
     * Factory
     *
     * @param string $namespace
     *
     * @return CreditCard
     * @throws \RuntimeException
     */
    public function create(string $namespace): CreditCard
    {
        if (!array_key_exists($namespace, $this->_collection)) {
            throw new \RuntimeException('Not found credit card.');
        }

        return new $this->_collection[$namespace]();
    }
}
