<?php

namespace Acms\Plugins\ShoppingCart\Services\Payment;

use Acms\Plugins\ShoppingCart\Services\Payment\PaymentMethodInterface;
use Acms\Services\Common\Factory;

class PaymentMethodFactory extends Factory
{
    protected string $default;

    /**
     * Factory
     *
     * @param string $namespace
     *
     * @return PaymentMethodInterface
     * @throws \RuntimeException
     */
    public function create(string $namespace): PaymentMethodInterface
    {
        if (!array_key_exists($namespace, $this->_collection)) {
            if (!array_key_exists($this->default, $this->_collection)) {
                throw new \RuntimeException('Not found payment method.');
            }
            return new $this->_collection[$this->default]();
        }

        return new $this->_collection[$namespace]();
    }

    /**
     * attach with default
     *
     * @param string $namespace
     * @param string $PaymentMethodClass
     *
     * @throws \RuntimeException
     */
    public function attachWithDefault(string $namespace, string $PaymentMethodClass): void
    {
        $this->attach($namespace, $PaymentMethodClass);
        $this->default = $namespace;
    }
}
