# テーマ「EC」2023/11/17版

## テーマフォルダ直下のテンプレート

### 404.html
404ページで表示されるテンプレートです。

### _edit.html
エントリー編集画面のテンプレートです。

### _entry.html
詳細ページのテンプレートです。

### _top.html
トップページのテンプレートです。

### index.html
一覧ページのテンプレートです。

### template.yaml
EC テーマを選択したときに、テンプレートをまとめて設定できるファイルです。使用するかどうかは管理画面＞コンフィグ＞テーマ設定 にて変更できます。


## フォルダ構成

### _layouts
テンプレートの継承機能で使用するファイルが入ったフォルダです。
用途としては、主に別テンプレートでレイアウトを統一するために使います。

### _member
会員機能に必要なテンプレートが入ったフォルダです。

### admin
EC テーマオリジナルの管理画面のテンプレートが入ったフォルダです。
EC テーマでは主に以下のテンプレートが入っています。

- カスタムフィールド（ブログ・カテゴリー・エントリー・モジュール・ユーザー）
- ダッシュボード
- 管理ボックス

### カテゴリーコード名フォルダ
a-blog cms で作ったカテゴリーと同じコード名でフォルダを作ると、その中にある index.html と _entry.html はそのカテゴリーの専用テンプレートとなります。
EC テーマでは以下のカテゴリー名フォルダを用意しています。

- about（このサイトについて）
- cart（カート）
- contact（お問い合わせ）
- mypage（マイページ）
- products（商品を探す）
- shopping（注文手続き）

### ajax
ショッピングカート機能で使用する POST モジュールの実行結果を出力するための JSON ファイルが格納されたフォルダです。

- ajax/cart/add.json: ショッピングカートに商品を追加する ShoppingCart_AddItem モジュールの実行結果を出力する JSON ファイルです。
- ajax/cart/remove.json: ショッピングカートから商品を削除する ShoppingCart_RemoveItem モジュールの実行結果を出力する JSON ファイルです。
- ajax/cart/update/quantity.json: ショッピングカートに商品を追加する ShoppingCart_Update_Quantity モジュールの実行結果を出力する JSON ファイルです。


### dest
EC テーマで使っているJSやCSSが入ったフォルダです。
src フォルダのファイルを結合したファイルです。
直接読み込むために使っているのは bunde.js 、vernder.js 、bundle.min.css です。

### images
EC テーマで使っている画像が入ったフォルダです

### include
EC テーマ内のインクルードしているテンプレートをまとめたフォルダです。

### mail
新規会員登録やパスワードリセットの際に使用されるメールテンプレートが入ったフォルダです。

### mypage
マイページのテンプレートが入ったフォルダです。

### cart
カートのテンプレートが入ったフォルダです。

### shopping
決済フォームのテンプレートが入ったフォルダです。

### src
EC テーマで使っている JavaScript や SCSS ファイルが入ったフォルダです。
この src/scss フォルダに入っている SCSS ファイルをコンパイルして CSS を出力しています。


## 利用している a-blog cms の基本機能

### 用意しているカスタムフィールド

#### ブログ

- サイトの設定（BID1のみ）
- 会社情報（BID1のみ）
- SNSアカウントの情報（BID1のみ）
- アクセス解析（BID1のみ）
- SEOの設定
- OGPの設定
- scriptタグ

#### カテゴリー
- SEOの設定
- OGPの設定

#### エントリー
- 商品情報（※ 「商品を探す」以下のみ）

#### モジュール
- サイト全体の色の設定
- カートに入れるボタン前の文章
- 商品に使用するラベル

#### 会員
- 会員情報（マイページの情報と同じ）

### フォーム
- 検索フォーム
- お問い合わせフォーム（お問い合わせページ）
- 決済フォーム（カートから決済ページまで移動できます）

### エントリーの固定表示
エントリー編集ページの詳細設定の中にあるファイル名の入力欄を空にすると、エントリーが固定表示される機能。「このサイトについて」のページで実装しています。

### API 機能
カート機能を実装のため、カート内商品一覧表示などで API 機能を利用しています。

管理画面 > コンフィグ > API 設定 から API 機能を有効化する必要があります。
また、API機能で使用しているモジュールのモジュールID 設定 > 条件設定から APIでの取得を許可を有効化する必要があります。

以下のモジュールID名のモジュールを API 機能で使用しています。

- summary_cart

API機能で使用しているモジュールを変更したい場合は、/include/head/js.html から変更できます。

### 会員登録機能

コンフィグ > 基本設定 > ログイン設定 > 会員登録機能から「ユーザー登録の外部申請」を有効にすることで、ユーザーを外部から登録できるようにカスタマイズしています。

ユーザー申請時やパスワードリセット時の自動返信メールについてはコンフィグ > 基本設定 > メール設定から設定できます。

## カスタマイズについて

### スライダーについて
スライダーは slick という jQuery プラグインを使用しています。使用方法についてはslickの公式サイトをご覧ください。
・ slick / http://kenwheeler.github.io/slick/

### ショッピングカートについて

ショッピングカート機能を実装するために Vue.js という JavaScript ライブラリを使用しています。

Vue.js 公式ドキュメント
https://ja.vuejs.org/

また、ショッピングカートのステート管理のため、Vuex という JavaScript ライブラリを使用しています。

Vuex 公式ドキュメント
https://vuex.vuejs.org/ja/


カートに追加するフォームやショッピングカート内商品一覧などは Vue.js によってコンポーネントとして実装されています。
以下、EC テーマで実装されているコンポーネントについて説明します。

#### add-to-cart

ショッピングカートに商品（エントリー）追加するためのフォームを表示します。

##### 使い方

``` html
<!-- include vue template -->
@include("/include/vue-template/add-to-cart.html")

<add-to-cart
  :eid="%{EID}"
  :title="{title}"
  :stock="<!-- BEGIN_IF [{item_stock}/isset] -->{item_stock}<!-- ELSE -->null<!-- END_IF -->"
></add-to-cart>
```

###### Props

- `eid` (`number`): ショッピングカートに追加する商品（エントリー）のエントリーIDを指定します。
- `title` (`string`): ショッピングカートに追加する商品（エントリー）のタイトルを指定します。
- `stock` （`number|null`）: ショッピングカートに追加する商品（エントリー）の在庫数を指定します。null が指定された場合は、在庫管理を行いません。

##### テンプレートのカスタマイズについて

HTML については以下のファイルでカスタマイズできます。

include/vue-template/add-to-cart.html

#### shopping-cart-badge

ショッピングカート内商品（エントリー）の数量合計を表示するためのバッジを表示します。

##### 使い方

``` html
<!-- include vue template -->
@include("/include/vue-template/shopping-cart-badge.html")

<shopping-cart-badge></shopping-cart-badge>
```

##### テンプレートのカスタマイズについて

HTML については以下のファイルでカスタマイズできます。

include/vue-template/shipping-cart-badge.html

#### shipping-cart-list

ショッピングカート内商品（エントリー）の一覧を表示します。

##### 使い方

``` html
<!-- include vue template -->
@include("/include/vue-template/shopping-cart-list.html")

<shopping-cart-list></shopping-cart-list>
```

##### テンプレートのカスタマイズについて

HTML については以下のファイルでカスタマイズできます。

include/vue-template/shopping-cart-list.html

#### shopping-cart-item

ショッピングカート内商品（エントリー）のデータを表示します。shipping-cart-list コンポーネントの子要素として使用できます。

##### 使い方

``` html
<!-- include vue template -->
@include("/include/vue-template/shopping-cart-item.html")

@verbatim
<script id="ShoppingCartList" type="text/x-template">
  <ul class="cart-list">
    <li
      v-for="item in items"
      :key="item.eid"
    >
      <shopping-cart-item
        :item="item"
        :isEditing="editing === item.eid"
        :onEditButtonClick="() => setEditing(item.eid)"
        :afterUpdate="() => setEditing(false)"
      ></shopping-cart-item>
    </li>
  </ul>
</script>
@endverbatim
```

###### Props

- `item` (`object`): ショッピングカート内商品（エントリー）のデータを指定します。
- `isEditing` （`boolean`）: ショッピングカート内商品（エントリー）の数量が編集中かどうかを指定します。
- `onEditButtonClick` (`Function`): ショッピングカート内商品（エントリー）の数量変更ボタンをクリックしたときの処理を指定します。
- `afterUpdate` （`Function`）: ショッピングカート内商品（エントリー）の数量が更新されたあとの処理を関数で指定します。
- `afterRemove` （`Function`）: ショッピングカート内商品（エントリー）が削除されたあとの処理を関数で指定します。

##### テンプレートのカスタマイズについて

HTML については以下のファイルでカスタマイズできます。

include/vue-template/shopping-cart-item.html

#### modal

モーダルコンポーネントを表示します。EC テーマでは、ショッピングカートに商品を追加したあとに表示されています。

Vue.js の [Slot](https://ja.vuejs.org/guide/components/slots.html) と、[Tleport](https://ja.vuejs.org/guide/built-ins/teleport.html) という機能を活用して実装されています。

##### 使い方

``` html
<!-- include vue template -->
@include("/include/vue-template/modal.html")

<modal
  :isOpen="added"
  :onClose="() => setAdded(false)"
  aria-labelledby="shopping-cart-modal-title"
  aria-describedby="shopping-cart-modal-content"
>
  <template #header>
    <h2 id="shopping-cart-modal-title" class="modal-title">「商品をカートに追加しました</h2>
  </template>
  <template #default>
    <div id="shopping-cart-modal-content" class="modal-img-wrap">
      <img
        class="acms-img-responsive"
        src="%{MEDIA_ARCHIVES_DIR}{item_image@path}[resizeImg(300)]"
        width="200"
        height="300"
        alt="商品画像"
      >
    </div>
  </template>
  <template #footer>
    <div class="modal-btn-wrap">
      <button type="button" class="btn is-secondary" @click="setAdded(false)">買い物を続ける</button>
      <a href="%{BASE_URL}cart/" class="btn">注文手続きに進む</a>
    </div>
  </template>
</modal>
```

###### Props

- `isOpen` (`boolean`): モーダルの開閉の状態を真偽値で指定します。
- `onClose` (`Function`): モーダルを閉じるための関数を指定します。`isOpen` に指定した Props を false に変更するための関数を指定してください。
- `container` (`string | HTMLElement`): モーダルを出力する親要素を指定します。セレクターまたは実際の要素のいずれかを指定できます。デフォルトは `document.body` です。
- `preventScroll` （`boolean`）: モーダルが開いている時に背景のスクロールを禁止するかどうかを真偽値で指定します。デフォルトは `true` です。
- `shouldCloseOnBackdropClick` (`boolean`): モーダルの背景要素をクリックした時にモーダルを閉じるかどうかを真偽値で指定します。デフォルトは `true` です。
- `shouldCloseOnEsc` (`boolean`): ESCキーを押した時にモーダルを閉じるかどうかを真偽値で指定します。デフォルトは `true` です。
- `closeTimeout` (`number`): モーダルを閉じる時に待機する時間をミリ秒で指定します。デフォルトは `0` です。
- `role` (`string`): モーダル要素に指定するrole属性を指定します。デフォルトは `dialog` です。
- `ariaModal` (`boolean`): モーダル要素に指定するaria-modal属性を真偽値で指定します。デフォルトは `true` です。
- `ariaLabelledby` (`string`): モーダルの `aria-labelledby` 属性を指定できます。
- `ariaDescribedby` (`string`): モーダルの `aria-describedby` 属性を指定できます。

###### Events

- `AfterOpen`: モーダルが開いたあとに発火します。
- `AfterClose`: モーダルが閉じたあとに発火します。

#### quantity-select

数量を選択するためのユーティリティコンポーネントです。初期状態は select タグで表示されますが、指定された数値を超えた値を選択すると input タグで表示されるようになります。

##### 使い方

``` html

<quantity-select
  v-model:quantity="quantity"
  :max-quantity="stock === null ? 9999 : Math.max(stock - addedQuantity, 0)"
  name="quantity"
/>
```

###### Props

- `name` (`string`): 入力フィールドのname属性を指定します。
- `quantity` （`number`）: 入力フィールドの初期値をしていします。
- `maxQuantity` （`number`）: select タグでの表示と input タグでの表示を切り替える閾値を指定します。
- `limit` （`number`）: maxQuantity の値の上限値を設定できます。デフォルトは10です。

##### テンプレートのカスタマイズについて

HTML については以下のファイルでカスタマイズできます。

src/js/components/QuantitySelect.js


### EU購入者のためのデータ収集の有効化
2018年よりEUにて一般データ保護規則（GDPR）が制定され、欧州に在住している方の個人情報を取得するためにはウェブサイト訪問者の事前同意が必要となりました。
必要であれば、機能をオンにしてください。

#### 主な関連するファイル
- /include/body-start.html
- /include/body-start/cookie-consent.html
- /src/scss/_cookie-consent.scss
- /admin/blog/script.html

#### 使用しているJSプラグイン
vanilla-cookieconsent
https://www.npmjs.com/package/vanilla-cookieconsent

#### 基本的な使い方
1. 管理画面＞ブログ管理の順にページを移動し、「EU購入者のためのデータ収集の有効化」を有効化する（有効化すると、/include/body-start.htmlに記述されている/include/body-start/cookie-consent.htmlが読み込まれます）
2. クッキーを使用しているJavaScriptのscript要素にtype="text/plain"とdata-cookiecategory="<category>"を追記してください（<category>にはcookie-consent.htmlのtoggleオブジェクトのvalueプロパティと同じ値を設定します）
3. /include/body-start/cookie-consent.html に制御したいカテゴリーをtoggleオブジェクトのvalueプロパティに追加します

#### 製品情報のCookieの出しわけ機能に適用する
管理画面＞ブログ管理の順にページを移動し、「EU購入者のためのデータ収集の有効化」を有効化する。
有効化した時点で、製品情報ページで使用しているCookieによるコンテンツの出しわけ機能は閲覧者から同意を得てから実行されるようになります。
（※製品情報のCookieの出しわけのJavaScript自体は/include/head/js.htmlに記述されています）

#### GAに適用する
管理画面＞ブログ管理のページで、Google Analyticsを設定します。
クッキーの同意ポップアップを使用する際は、script要素にtype="text/plain"とdata-cookiecategory="<category>"を追記してください（<category>にはcookie-consent.htmlのtoggleオブジェクトのvalueプロパティと同じ値を設定します）
あらかじめ、通常であればテンプレートに記述しますが、cookie-consent.htmlでanalyticsカテゴリーが事前に設定されているので、以下のようにカスタムフィールドに設定します。

記述例）管理画面＞ブログ管理のページで、Google Analyticsを設定する

```html
<!-- Global site tag (gtag.js) - Google Analytics -->
<script type="text/plain" data-cookiecategory="analytics" async src="https://www.googletagmanager.com/gtag/js?id=GA_MEASUREMENT_ID"></script>
<script type="text/plain" data-cookiecategory="analytics">
    window.dataLayer = window.dataLayer || [];
    function gtag(){window.dataLayer.push(arguments);}
    gtag('js', new Date());

    gtag('config', 'GA_MEASUREMENT_ID');
</script>
```

#### スタイルを修正したい
スタイルを修正したい場合には、/src/scss/_cookie-consent.scssを使って修正してください。

#### 文言を修正したい
文言を修正する時は、/include/body-start/cookie-consent.htmlに書かれているJavaScriptの部分を修正します。
言語ごとのオブジェクトを増やせば多言語対応することも可能です。

#### 訪問者がいつでも設定を変更できるようにする
以下のボタンをページ内のどこかに設置すれば、いつでも訪問者が設定を変更できます。
```
<a href="javascript:void(0);" aria-label="クッキーの設定を表示する" data-cc="c-settings">クッキーの設定を変更する</a>
```

#### 規約を変更したので再度モーダルを表示したい
規約を変更した場合は、revisionプロパティの値を変更することで、再度訪問者にポップアップを表示することが可能です。


## 開発環境について

ECテーマでは、以下の作業のために開発環境を整えています。

* JSやCSSなどのファイルを1つにまとめる
* SCSSをCSSに変換する
* ソースコードを整形する

ここでは簡単に説明しておりますが、もっと詳しく知りたい場合は[公式テーマの webpack ビルド環境の使い方](https://developer.a-blogcms.jp/document/themes/webpack.html)をご覧ください。

### 使い方

1. themes/ec で `npm ci`してテーマで使用している全ての npm パッケージをインストールする
2. 管理画面 > コンフィグ > API 設定で API 機能が有効化されていることを確認します。
3. その後、`npm run start` または `npm run dev` で開発を開始します。（JSやCSSが1つのファイルにまとめられる他、SCSSをCSSに自動で変換します）
4. リリースできるようになったら、`npm run build` でビルドします。

マシンにnode.jsが入っていない方はnpmコマンドが使えないため、[公式サイト](https://nodejs.org/ja/)からインストールしてください。
.node-versionに記載しているバージョンと同じバージョンをインストールしてください。

### package.json
package.jsonにはECテーマで使用できるコマンドと使用しているパッケージがリストされています。

以下、一部の設定について紹介します。

#### package.jsonのconfig
* local ... 後述する npm run start のライブリロードで使用します。開発環境を表示しているドメインなどあれば記入してください。
* theme ... 使用しているテーマを記述します

#### package.jsonのscripts
* npm run build ... リリース用のCSSとJSを書き出します
* npm run dev ... 開発時用のCSSとJSを書き出します。（ソースマップを書き出すので、開発者ツール上からどのSCSSファイルのコードかわかります）
* npm run start ... devの機能に加えて、さらにライブリロードを行います
* npm run analyze ... 結合したファイルの各パッケージがどのくらいの容量を占めているか可視化してくれる機能です。

### webpack
* webpack.analyze.js ... バンドルファイル内の各パッケージがどのくらいの容量を占めているか知りたい場合に使用する
* webpack.common.js ... 各script実行時に共通の設定ファイル
* webpack.dev.js ... 開発中のタスクに使用する
* webpack.prod.js ... リリース時のタスクに使用する
* webpack.uncompress.js ... 非圧縮のCSSをビルドするときに使用する

### 不可視ファイル
* .editorconfig ... 自動で整形してくれるeditorconfigの設定ファイル
* .eslintrc ... ESLintの設定ファイル（JS関係）
* .gitignore ... Gitで管理しないものを設定するファイル
* .node-version ... node.jsのバージョンを管理するファイル。開発時に使用されたNode.jsのバージョンが記載されており、nodenvなどのバージョン管理ツール使用時に適用されます。
* .stylelintrc ... StyleLintの設定ファイル（SCSS、CSS関係）
