import { onUnmounted } from 'vue';
import { hideOthers } from 'aria-hidden';

export const useAriaHidden = (targetRef, parentRef, markerName) => {
  let undo;

  const hide = () => {
    if (targetRef.value) {
      undo = hideOthers(
        targetRef.value,
        parentRef?.value,
        markerName,
      );
    }
  };

  const unhide = () => {
    if (undo && typeof undo === 'function') {
      undo();
    }
  };

  onUnmounted(() => unhide());

  return {
    hide,
    unhide,
  };
};
