import { onUnmounted } from 'vue';
import { clearAllBodyScrollLocks, disableBodyScroll, enableBodyScroll } from 'body-scroll-lock';

export const useBodyScrollLock = (targetRef) => {
  const disableScroll = (options) => targetRef.value && disableBodyScroll(targetRef.value, options);
  const enableScroll = () => targetRef.value && enableBodyScroll(targetRef.value);

  onUnmounted(() => clearAllBodyScrollLocks());

  return {
    disableScroll,
    enableScroll,
  };
};
