/**
 * @see https://github.com/idea2app/event-submitter-polyfill
 */

const submitableButton = 'button, input[type="button"], input[type="submit"], input[type="image"]';

let lastButton;

document.addEventListener(
  'click',
  (event) => (lastButton = (event.target).closest?.(
    submitableButton,
  )),
  true,
);

document.addEventListener(
  'submit',
  (event) => {
    if (lastButton && event.submitter) {
      return;
    }

    Object.defineProperty(Object.getPrototypeOf(event), 'submitter', {
      configurable: true,
      enumerable: true,
      get() {
        const form = this.target;
        const canditates = [document.activeElement, lastButton];

        let result = null;
        canditates.forEach((control) => {
          if (control?.matches(submitableButton) && form === control.form) {
            result = control;
          }
        });

        return result;
      },
    });
  },
  true,
);

document.addEventListener('submit', () => (lastButton = undefined));
