import axios, { AxiosError } from 'axios';

/**
 * デフォルト config の設定
 */
const axiosClient = axios.create({
  baseURL: window.BASE_URL,
});

/**
 * リクエスト インターセプター
 */
axiosClient.interceptors.request.use((config) => {
  if (config.method === 'get') {
    config.headers['X-API-KEY'] = window['X-API-KEY'];
  }
  return config;
});

/**
 * レスポンス インターセプター
 */
axiosClient.interceptors.response.use((response) => {
  if (response.data.status === 'failure') {
    throw new AxiosError(
      'Failed to operate cart.',
      response.status,
      response.config,
      response.request,
      response,
    );
  }
  return response;
});

export default axiosClient;
