import * as api from '../../../api';

const actions = {
  getCart: async ({ commit }) => {
    const cart = await api.getCart();
    commit('SET_CART', cart);
  },

  addToCart: async ({ commit }, formData) => {
    const newItem = await api.addToCart(formData);
    commit('ADD_TO_CART', newItem);
  },

  removeFromCart: async ({ commit }, formData) => {
    await api.removeFromCart(formData);
    commit('REMOVE_FROM_CART', parseInt(formData.get('eid'), 10));
  },

  updateQuantity: async ({ commit }, formData) => {
    const newItem = await api.updateQuantity(formData);
    commit('UPDATE_QUANTITY', newItem);
  },
};

export default actions;
