const mutations = {
  SET_CART(state, cart) {
    state.cart = cart;
  },

  ADD_TO_CART({ cart }, newItem) {
    cart.items = [
      ...cart.items.filter((item) => item.eid !== parseInt(newItem.eid, 10)),
      { ...(cart.items.find((item) => item.eid === parseInt(newItem.eid, 10)) ?? {}), ...newItem },
    ];
  },

  REMOVE_FROM_CART({ cart }, eid) {
    cart.items = cart.items.filter((item) => item.eid !== parseInt(eid, 10));
  },

  UPDATE_QUANTITY({ cart }, newItem) {
    cart.items = cart.items.map((item) => (item.eid === parseInt(newItem.eid, 10) ? { ...item, ...newItem } : item));
  },

  SET_LOADING(state, isLoading) {
    state.isLoading = isLoading;
  },

  SET_VALIDATING(state, isValidating) {
    state.isValidating = isValidating;
  },
};

export default mutations;
