import axiosClient from '../lib/axiosClient';

export const getCart = async () => {
  const { ShoppingCart_Summary: moduleId } = window.ShoppingCart.moduleId;
  const { data } = await axiosClient.get(`/api/${moduleId}/?date=${new Date().getTime()}`);
  return {
    items: data['entry:loop'] ?? [],
    taxes: data['taxAmount:loop'] ?? [],
    subtotal: data.subtotal,
  };
};

export const addToCart = async (formData) => {
  formData.append('ACMS_POST_ShoppingCart_AddItem', 'true');
  const { data } = await axiosClient.post('/ajax/cart/add.json', formData);
  return data.item;
};

export const updateQuantity = async (formData) => {
  formData.append('ACMS_POST_ShoppingCart_Update_Quantity', 'true');
  const { data } = await axiosClient.post('/ajax/cart/update/quantity.json', formData);
  return data.item;
};

export const removeFromCart = async (formData) => {
  formData.append('ACMS_POST_ShoppingCart_RemoveItem', 'true');
  await axiosClient.post('/ajax/cart/remove.json', formData);
};
