import { createApp } from 'vue';
import store from './store';

import {
  AddToCart, ShoppingCartBadge, ShoppingCartList,
} from './components';

export default async (context, selector = '.js-shopping-cart') => {
  const templates = context.querySelectorAll(selector);
  [].forEach.call(templates, (template) => {
    createApp({})
      .component('AddToCart', AddToCart)
      .component('ShoppingCartBadge', ShoppingCartBadge)
      .component('ShoppingCartList', ShoppingCartList)
      .use(store)
      .mount(template);
  });

  try {
    store.commit('cart/SET_LOADING', true);
    await store.dispatch('cart/getCart');
  } catch (e) {
    console.error(e);
  } finally {
    store.commit('cart/SET_LOADING', false);
  }
};
